SystemOrganization addCategory: #'Javascript-Tests-Core'!

WAContextTest subclass: #JSObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

JSObjectTest subclass: #JSConversionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testArray
	self assert: #(1 2 3) equals: '[1,2,3]'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:51'!
testCharacter
	self assert: (Character codePoint: 0) equals: '"\0"'.
	self assert: Character lf equals: '"\n"'.
	self assert: $a equals: '"a"'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testColor
	self assert: Color red equals: '"#FF0000"'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testDateAndTime
	self assert: (DateAndTime year: 1980 month: 6 day: 11 hour: 12 minute: 45 second: 23) equals: 'new Date(1980,5,11,12,45,23)'.
	self assert: (Date year: 1980 month: 6 day: 11) equals: 'new Date(1980,5,11)'! !

!JSConversionTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:26'!
testDictionary
	self 
		assert: (GRSmallDictionary new
				at: 'foo'
					put: 1;
				at: 'bar'
					put: 2;
				at: 'zork'
					put: 3;
				yourself)
		equals: '{foo:1,bar:2,zork:3}'.
	self 
		assert: (GRSmallDictionary new
				at: ''
					put: 'empty';
				yourself)
		equals: '{"":"empty"}'.
	self 
		assert: (Dictionary new
				at: 1
					put: 'not-a-string';
				yourself)
		equals: '{"1":"not-a-string"}'.
	self 
		assert: (Dictionary new
				at: '1abc'
					put: 'not-an-id';
				yourself)
		equals: '{"1abc":"not-an-id"}'.
	self 
		assert: (Dictionary new
				at: 'abc1'
					put: 'totally sexy';
				yourself)
		equals: '{abc1:"totally sexy"}'! !

!JSConversionTest methodsFor: 'testing' stamp: 'jf 2/6/2010 00:26'!
testDuration
	self assert: (Duration seconds: 1) equals: '1000'.
	self assert: (Duration milliseconds: 1200) equals: '1200'! !

!JSConversionTest methodsFor: 'testing-tools' stamp: 'lr 4/28/2009 20:37'!
testIsJavascript
	self deny: 123 isJavascript.
	self assert: self mock isJavascript.
	self assert: JSCreate new isJavascript! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/16/2008 19:45'!
testJoin
	self 
		assert: (JSJoin new)
		equals: '""'.
	self
		assert: (JSJoin on: #('foo')) 
		equals: '"foo"'.
	self
		assert: (JSJoin on: #('foo' 'bar'))
		equals: '["foo","bar"].join("&")'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testLiteral
	self assert: true equals: 'true'.
	self assert: false equals: 'false'.
	self assert: nil equals: 'null'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testNumber
	self assert: 123 equals: '123'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testStringBasic
	self assert: 'abc' equals: '"abc"'.
	self assert: '123' equals: '"123"'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testStringEscaping
	self assert: '''' equals: '"''"'.
	self assert: '"' equals: '"\""'.
	self assert: '\' equals: '"\\"'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:52'!
testStringSpecial
	self assert: (String with: Character cr) equals: '"\r"'.
	self assert: (String with: Character lf) equals: '"\n"'.
	self assert: (String with: Character tab) equals: '"\t"'.

	self assert: (String with: (Character codePoint: 0)) equals: '"\0"'.
	self assert: (String with: (Character codePoint: 1)) equals: '"\x01"'.
	self assert: (String with: (Character codePoint: 31)) equals: '"\x1f"'! !

!JSConversionTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:48'!
testUrl
	self
		assert: (WAUrl absolute: 'http://www.seaside.st/?1=a&2=b')
		equals: '"http://www.seaside.st/?1=a&2=b"'! !

JSObjectTest subclass: #JSDecorationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testAccess
	self
		assert: (self mock access: 'foo')
		equals: 'mock.foo'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testAlias
	| mock |
	mock := self mock.
	mock alias: 'foo'.
	self assert: mock equals: 'foo'.
	mock alias: 'bar'; call: 'zork'.
	self assert: mock equals: 'bar.zork()'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testApply
	self
		assert: (self mock apply: #())
		equals: 'mock()'.
	self
		assert: (self mock apply: #(1))
		equals: 'mock(1)'.
	self
		assert: (self mock apply: #(1 true))
		equals: 'mock(1,true)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:01'!
testAssign
	self
		assert: (self mock assign: 1)
		equals: 'mock=1'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testAssignLocalTo
	self
		assert: (self mock assignLocalTo: 'x')
		equals: 'var x=mock'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testAssignTo
	self
		assert: (self mock assignTo: 'x')
		equals: 'x=mock'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testBinary
	self
		assert: (self mock & false)
		equals: 'mock&&false'.
	self
		assert: (self mock | 1)
		equals: 'mock||1'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:09'!
testCall
	self
		assert: (self mock call: 'foo')
		equals: 'mock.foo()'.
	self
		assert: (self mock call: nil)
		equals: 'mock()'.
	self
		assert: (self mock call: '')
		equals: 'mock()'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:09'!
testCallWith
	self
		assert: (self mock call: 'foo' with: 1)
		equals: 'mock.foo(1)'.
	self
		assert: (self mock call: nil with: 1)
		equals: 'mock(1)'.
	self
		assert: (self mock call: '' with: 1)
		equals: 'mock(1)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:10'!
testCallWithArguments
	self
		assert: (self mock call: 'foo' withArguments: #(1 2 3 4 5))
		equals: 'mock.foo(1,2,3,4,5)'.
	self
		assert: (self mock call: nil withArguments: #(1 2 3 4 5))
		equals: 'mock(1,2,3,4,5)'.
	self
		assert: (self mock call: '' withArguments: #(1 2 3 4 5))
		equals: 'mock(1,2,3,4,5)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:10'!
testCallWithWith
	self
		assert: (self mock call: 'foo' with: 1 with: 2)
		equals: 'mock.foo(1,2)'.
	self
		assert: (self mock call: nil with: 1 with: 2)
		equals: 'mock(1,2)'.
	self
		assert: (self mock call: '' with: 1 with: 2)
		equals: 'mock(1,2)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:10'!
testCallWithWithWith
	self
		assert: (self mock call: 'foo' with: 1 with: 2 with: 3)
		equals: 'mock.foo(1,2,3)'.
	self
		assert: (self mock call: nil with: 1 with: 2 with: 3)
		equals: 'mock(1,2,3)'.
	self
		assert: (self mock call: '' with: 1 with: 2 with: 3)
		equals: 'mock(1,2,3)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/14/2008 12:22'!
testConcatenate
	self
		assert: (self mock , 2 , 3)
		equals: 'mock;2;3'.
	self
		assert: (self mock , nil , self mock)
		equals: 'mock;null;mock'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testCondition
	self
		assert: (self mock condition: true)
		equals: 'if(true){mock}'.
	self
		assert: (self mock condition: false)
		equals: 'if(false){mock}'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testConfirm
	self
		assert: (self mock confirm: 'Sure?')
		equals: 'if(confirm("Sure?")){mock}'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testCreate
	self
		assert: self mock create
		equals: 'new mock'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:01'!
testInterval
	self
		assert: (self mock interval: 2 seconds)
		equals: 'setInterval(function(){mock},2000)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testNot
	self
		assert: self mock not
		equals: '!!mock'.
	self
		assert: self mock not not
		equals: '!!!!mock'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testProperty
	self
		assert: (self mock property: 'foo')
		equals: 'mock["foo"]'.
	self
		assert: (self mock property: 123)
		equals: 'mock[123]'.
	self
		assert: (self mock property: 'foo'; assign: 'bar')
		equals: 'mock["foo"]="bar"'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testReturn
	self
		assert: (self mock return: 1)
		equals: 'mock;return 1'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testThenElse
	| mock |
	mock := self mock.
	mock then: 1.
	self assert: mock equals: '(mock?1:null)'.

	mock := self mock.
	mock then: 1 else: 2.
	self assert: mock equals: '(mock?1:2)'! !

!JSDecorationTest methodsFor: 'testing' stamp: 'lr 10/13/2008 21:58'!
testTimeout
	| mock |
	mock := self mock.
	mock timeout: 123.
	self assert: mock equals: 'setTimeout(function(){mock},123)'! !

JSObjectTest subclass: #JSJsonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSJsonTest methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:45'!
json
	^ JSJson context: self renderContext! !

!JSJsonTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:51'!
testParse
	self 
		assert: (self json parse: '[1,2]')
		equals: 'JSON.parse("[1,2]")'.
	self 
		assert: (self json parse: '[1,2]' reviver: 'return null')
		equals: 'JSON.parse("[1,2]",function(){return null})'! !

!JSJsonTest methodsFor: 'testing' stamp: 'lr 9/22/2009 10:51'!
testStringify
	self 
		assert: (self json stringify: self mock)
		equals: 'JSON.stringify(mock)'.
	self 
		assert: (self json stringify: self mock space: 4)
		equals: 'JSON.stringify(mock,4)'.
	self 
		assert: (self json stringify: self mock replacer: #())
		equals: 'JSON.stringify(mock,[])'.
	self 
		assert: (self json stringify: self mock replacer: #() space: ' ')
		equals: 'JSON.stringify(mock,[]," ")'! !

JSObjectTest subclass: #JSLoggingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSLoggingTest methodsFor: 'accessing' stamp: 'jf 7/19/2009 14:58'!
logger
	^ JSLogger context: self renderContext! !

!JSLoggingTest methodsFor: 'testing' stamp: 'lr 4/28/2009 20:41'!
testAssert
	self 
		assert: (self logger assert: true)
		equals: 'console.assert(true)'.
	self
		assert: (self logger assertTrue: true)
		equals: 'console.assertTrue(true)'.
	self 
		assert: (self logger assertFalse: false)
		equals: 'console.assertFalse(false)'.
	self
		assert: (self logger assertNull: nil)
		equals: 'console.assertNull(null)'.
	self
		assert: (self logger assertNotNull: 1)
		equals: 'console.assertNotNull(1)'.
	self
		assert: (self logger assertUndefined: nil)
		equals: 'console.assertUndefined(null)'.
	self
		assert: (self logger assertNotUndefined: 1)
		equals: 'console.assertNotUndefined(1)'! !

!JSLoggingTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:06'!
testComparison
	self
		assert: (self logger assert: 1 equals: 1)
		equals: 'console.assertEquals(1,1)'.
	self
		assert: (self logger assert: 1 notEquals: 2)
		equals: 'console.assertNotEquals(1,2)'.
	self
		assert: (self logger assert: 1 greater: 2)
		equals: 'console.assertGreater(1,2)'.
	self
		assert: (self logger assert: 2 notGreater: 1)
		equals: 'console.assertNotGreater(2,1)'.
	self
		assert: (self logger assert: 2 less: 1)
		equals: 'console.assertLess(2,1)'.
	self
		assert: (self logger assert: 1 notLess: 2)
		equals: 'console.assertNotLess(1,2)'! !

!JSLoggingTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:06'!
testLogging
	self
		assert: (self logger log: 'done')
		equals: 'console.log("done")'.
	self
		assert: (self logger log: 'done %s and %s' format: #( 'this' 'that' ))
		equals: 'console.log("done %s and %s","this","that")'! !

!JSLoggingTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:06'!
testMessages
	self
		assert: (self logger debug: 3)
		equals: 'console.debug(3)'.
	self
		assert: (self logger info: 'eye m here 2')
		equals: 'console.info("eye m here 2")'.
	self
		assert: (self logger warn: 'don"t 4get ur grlfrnd')
		equals: 'console.warn("don\"t 4get ur grlfrnd")'.
	self
		assert: (self logger error: 'gone gone gone')
		equals: 'console.error("gone gone gone")'! !

!JSObjectTest class methodsFor: 'testing' stamp: 'lr 11/15/2008 20:28'!
isAbstract
	^ self name = #JSObjectTest! !

!JSObjectTest class methodsFor: 'accessing' stamp: 'lr 4/28/2009 19:43'!
packageNamesUnderTest
	^ #('Javascript-Core')! !

!JSObjectTest class methodsFor: 'testing' stamp: 'lr 2/2/2010 21:57'!
shouldInheritSelectors
	^ true! !

!JSObjectTest methodsFor: 'utilities' stamp: 'lr 1/28/2010 17:32'!
assert: anObject equals: aString
	self
		assert: anObject asJavascript = aString
		description: anObject asJavascript printString , ' expected to be ' , aString printString
		resumable: true! !

!JSObjectTest methodsFor: 'utilities' stamp: 'jf 1/23/2009 13:16'!
assert: aBlock renders: aString 
	| html |
	html := WARenderCanvas builder
		documentClass: JSDocument;
		rootClass: WARoot;
		fullDocument: true;
		render: aBlock.
	self assert: html = aString! !

!JSObjectTest methodsFor: 'accessing-javascript' stamp: 'jf 7/19/2009 15:54'!
javascript
	^ JSScript context: self renderContext! !

!JSObjectTest methodsFor: 'accessing-javascript' stamp: 'lr 10/13/2008 21:59'!
mock
	^ JSStream on: 'mock'! !

!JSObjectTest methodsFor: 'accessing' stamp: 'jf 7/19/2009 14:55'!
renderContext
	^ WARenderContext new
		actionUrl: (WAUrl absolute: 'http://www.seaside.st/?_s=1&_k=a');
		document: (WAHtmlDocument 
			on: (WriteStream on: String new)
			codec: self requestContext codec);
		yourself! !

!JSObjectTest methodsFor: 'accessing-javascript' stamp: 'lr 10/15/2008 21:43'!
stream
	^ JSStream new! !

JSObjectTest subclass: #JSRenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:29'!
testAddToEvent
	self 
		assert: [ :html | html div onClick: self mock ]
		renders: '<div onclick="mock"></div>'.
	self 
		assert: [ :html | html div onMouseOut: self mock ]
		renders: '<div onmouseout="mock"></div>'.
	self 
		assert: [ :html | html div onKeyUp: self mock ]
		renders: '<div onkeyup="mock"></div>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:30'!
testAddToScript
	self 
		assert: [ :html | html script: self mock ]
		renders: '<script type="text/javascript">/*<!![CDATA[*/mock/*]]>*/</script>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 4/28/2009 20:30'!
testJavascript
	self 
		assert: [ :html | html div onClick: (html javascript add: self mock; add: self mock; yourself) ]
		renders: '<div onclick="mock;mock"></div>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 4/28/2009 20:29'!
testLogger
	self 
		assert: [ :html | html div onClick: (html logger log: 'Foo') ]
		renders: '<div onclick="console.log(&quot;Foo&quot;)"></div>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 4/28/2009 20:31'!
testPassenger
	self 
		assert: [ :html | html div passenger: self ]
		renders: '<div id="id1"></div>'.
	self 
		assert: [ :html | 
			html div passenger: self.
			html div passenger: self class ]
		renders: '<div id="id1"></div><div id="id2"></div>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 5/5/2009 00:19'!
testRenderOn
	self 
		assert: [ :html | html html: (html javascript render: 123) ]
		renders: '123'.
	self 
		assert: [ :html | html html: (html javascript render: 'abc') ]
		renders: 'abc'.
	self 
		assert: [ :html | html html: (html javascript render: [ :h | h div ]) ]
		renders: '<div></div>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 4/28/2009 20:36'!
testScript
	self 
		assert: [ :html | html div script: self mock ]
		renders: '<div></div><script type="text/javascript">/*<!![CDATA[*/mock/*]]>*/</script>'! !

!JSRenderingTest methodsFor: 'testing' stamp: 'lr 5/5/2009 00:19'!
testScriptOn
	self 
		assert: [ :html | html html: (html javascript script: [ :s | ]) ]
		renders: ''.
	self 
		assert: [ :html | html html: (html javascript script: [ :s | s add: self mock ]) ]
		renders: 'mock'.
	self 
		assert: [ :html | html html: (html javascript script: [ :s | s add: self mock; add: self mock ]) ]
		renders: 'mock;mock'! !

JSObjectTest subclass: #JSScriptTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSScriptTest methodsFor: 'accessing' stamp: 'jf 7/19/2009 14:56'!
function
	^ JSFunction context: self renderContext! !

!JSScriptTest methodsFor: 'accessing' stamp: 'jf 7/19/2009 14:56'!
script
	^ JSScript context: self renderContext! !

!JSScriptTest methodsFor: 'testing-compose' stamp: 'lr 4/28/2009 20:11'!
testAdd
	| script element |
	script := self script.
	element := self stream nextPutAll: 'foo'.
	self assert: (script add: element) == element.
	self assert: script equals: 'foo'.
	element := self stream nextPutAll: 'bar'.
	self assert: (script add: element) == element.
	self assert: script equals: 'foo;bar'! !

!JSScriptTest methodsFor: 'testing-compose' stamp: 'lr 4/28/2009 20:11'!
testAddAll
	| script elements |
	script := self script.
	elements := Array 
		with: (self stream nextPutAll: 'foo')
		with: (self stream nextPutAll: 'bar').
	self assert: (script addAll: elements) == elements.
	self assert: script equals: 'foo;bar'! !

!JSScriptTest methodsFor: 'testing-utilities' stamp: 'lr 4/28/2009 20:13'!
testAlert
	self assert: (self script alert: 'Be Alert') equals: 'alert("Be Alert")'! !

!JSScriptTest methodsFor: 'testing-function' stamp: 'lr 4/28/2009 20:40'!
testArgument
	| function |
	function := self function arguments: #(a b c).
	self assert: (function argument = #(a b c)).
	self assert: (function arguments = #(a b c))! !

!JSScriptTest methodsFor: 'testing-function' stamp: 'lr 4/28/2009 20:40'!
testArguments
	self
		assert: (self function arguments: #(a))
		equals: 'function(a){}'.
	self
		assert: (self function arguments: #(a b))
		equals: 'function(a,b){}'! !

!JSScriptTest methodsFor: 'testing-function' stamp: 'lr 4/28/2009 20:39'!
testAsFunction
	self
		assert: (self script asFunction: #(a))
		equals: 'function(a){}'.
	self
		assert: (self function asFunction: #(a b))
		equals: 'function(a,b){}'! !

!JSScriptTest methodsFor: 'testing-utilities' stamp: 'lr 4/28/2009 20:14'!
testCallback
	self assert: (self script callback: [ ]) equals: 'window.location="http://www.seaside.st/?_s=1&_k=a&1"'! !

!JSScriptTest methodsFor: 'testing-compose' stamp: 'lr 4/28/2009 20:11'!
testComma
	| script element |
	script := self script.
	element := self stream nextPutAll: 'foo'.
	self assert: (script , element) == script.
	self assert: script equals: 'foo'.
	element := self stream nextPutAll: 'bar'.
	self assert: (script , element) == script.
	self assert: script equals: 'foo;bar'! !

!JSScriptTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:14'!
testConvert
	self
		assert: self function
		equals: 'function(){}'.
	self
		assert: self function asFunction
		equals: 'function(){}'.
	self 
		assert: 'alert("1")' asFunction
		equals: 'function(){alert("1")}'! !

!JSScriptTest methodsFor: 'testing' stamp: 'lr 4/28/2009 20:11'!
testEmpty
	self assert: self script equals: ''! !

!JSScriptTest methodsFor: 'testing-utilities' stamp: 'lr 4/28/2009 20:13'!
testGoto
	self assert: (self script goto: 'http://www.seaside.st') equals: 'window.location="http://www.seaside.st"'! !

!JSScriptTest methodsFor: 'testing-utilities' stamp: 'lr 4/28/2009 20:26'!
testLogger
	self assert: (self script logger log: 'Hello Wold') equals: 'console.log("Hello Wold")'! !

!JSScriptTest methodsFor: 'testing-utilities' stamp: 'lr 4/28/2009 20:14'!
testRefresh
	self assert: self script refresh equals: 'window.location="http://www.seaside.st/?_s=1&_k=a"'! !

!JSScriptTest methodsFor: 'testing-function' stamp: 'lr 4/28/2009 20:12'!
testReturn
	| function |
	function := self function.
	function add: (self stream nextPutAll: 'foo').
	function add: (self stream nextPutAll: 'bar').
	function add: (self stream nextPutAll: 'baz').
	self assert: function equals: 'function(){foo;bar;baz}'.

	function := self function return: true.
	function add: (self stream nextPutAll: 'foo').
	function add: (self stream nextPutAll: 'bar').
	function add: (self stream nextPutAll: 'baz').
	self assert: function equals: 'function(){foo;bar;return baz}'! !

!JSScriptTest methodsFor: 'testing-compose' stamp: 'lr 4/28/2009 20:11'!
testShift
	| script element |
	script := self script.
	element := self stream nextPutAll: 'foo'.
	self assert: (script << element) == element.
	self assert: script equals: 'foo'.
	element := self stream nextPutAll: 'bar'.
	self assert: (script << element) == element.
	self assert: script equals: 'foo;bar'! !

JSObjectTest subclass: #JSStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSStreamTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:13'!
testArgument
	| stream |
	stream := self stream argument: 1.
	self assert: stream contents = '(1)'! !

!JSStreamTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:13'!
testArguments
	| stream |
	stream := self stream arguments: #(1 2 3).
	self assert: stream contents = '(1,2,3)'! !

!JSStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:43'!
testCharacter
	self assert: $a equals: '"a"'! !

!JSStreamTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:13'!
testCopy
	| stream1 stream2 |
	stream1 := self stream nextPutAll: 'foo'.
	stream2 := stream1 copy nextPutAll: 'bar'.
	stream1 nextPutAll: 'zork'.
	self assert: stream1 contents = 'foozork'.
	self assert: stream2 contents = 'foobar'! !

!JSStreamTest methodsFor: 'testing-encoding' stamp: 'pmm 8/30/2009 19:11'!
testEncodeKeyValueOn
	| actual |
	actual := String streamContents: [ :stream |
		JSStream encodeKey: 'key' value: 'value' on: stream ].
	self assert: actual = 'key:"value"'! !

!JSStreamTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:13'!
testJavascript
	| stream |
	stream := self stream javascript: #(1 2).
	self assert: stream contents = '[1,2]'! !

!JSStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 21:58'!
testLiteral
	self assert: true equals: 'true'.
	self assert: false equals: 'false'.
	self assert: nil equals: 'null'! !

!JSStreamTest methodsFor: 'testing-constructor' stamp: 'lr 4/28/2009 19:58'!
testNewArgument
	self assert: (JSStream argument: 0) equals: 'arguments[0]'.
	self assert: (JSStream argument: 1) equals: 'arguments[1]'.
	self deny: (JSStream argument: 1) == (JSStream argument: 1)! !

!JSStreamTest methodsFor: 'testing-constructor' stamp: 'lr 4/28/2009 19:59'!
testNewArgumentAt
	self assert: (JSStream argumentAt: 1) equals: 'arguments[0]'.
	self assert: (JSStream argumentAt: 2) equals: 'arguments[1]'.
	self deny: (JSStream argumentAt: 1) == (JSStream argument: 1)! !

!JSStreamTest methodsFor: 'testing-constructor' stamp: 'lr 4/28/2009 19:58'!
testNewOn
	self assert: (JSStream on: 'mock') equals: 'mock'! !

!JSStreamTest methodsFor: 'testing-constructor' stamp: 'lr 4/28/2009 19:58'!
testNewThis
	self assert: JSStream this equals: 'this'.
	self deny: JSStream this == JSStream this! !

!JSStreamTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:13'!
testNextPut
	| stream |
	stream := self stream nextPut: $f.
	self assert: stream contents = 'f'! !

!JSStreamTest methodsFor: 'testing' stamp: 'lr 10/13/2008 22:13'!
testNextPutAll
	| stream |
	stream := self stream nextPutAll: 'foo'.
	self assert: stream contents = 'foo'! !

!JSStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 21:58'!
testNumber
	self assert: 123 equals: '123'.
	self assert: 123.4 equals: '123.4'.! !

!JSStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 21:58'!
testStringBasic
	self assert: 'abc' equals: '"abc"'.
	self assert: '123' equals: '"123"'! !

!JSStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 21:58'!
testStringEscaping
	self assert: '''' equals: '"''"'.
	self assert: '"' equals: '"\""'.
	self assert: '\' equals: '"\\"'! !

!JSStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 21:58'!
testStringSpecial
	self assert: (String with: Character cr) equals: '"\r"'.
	self assert: (String with: Character lf) equals: '"\n"'.
	self assert: (String with: Character tab) equals: '"\t"'.

	self assert: (String with: (Character codePoint: 0)) equals: '"\0"'.
	self assert: (String with: (Character codePoint: 1)) equals: '"\x01"'.
	self assert: (String with: (Character codePoint: 31)) equals: '"\x1f"'! !

TestCase subclass: #JSJsonParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSJsonParserTest methodsFor: 'utilities' stamp: 'lr 6/25/2009 23:26'!
assertInvalid: aString
	self should: [ self parse: aString ] raise: JSJsonSyntaxError! !

!JSJsonParserTest methodsFor: 'utilities' stamp: 'pmm 12/15/2008 19:42'!
parse: aString
	^ JSJsonParser parse: aString! !

!JSJsonParserTest methodsFor: 'testing-array' stamp: 'lr 6/25/2009 23:24'!
testBigArray
	| result |
	result := self parse: ' [ "a" , "b" ] '.
	self assert: result isArray.
	self assert: result size = 2.
	self assert: result first = 'a'.
	self assert: result second = 'b'.! !

!JSJsonParserTest methodsFor: 'testing-objects' stamp: 'pmm 12/15/2008 19:59'!
testBigObject
	| result |
	result := self parse: ' { "a" : 1 , "b" : 2 } '.
	self assert: result isDictionary.
	self assert: result size = 2.
	self assert: (result at: 'a') = 1.
	self assert: (result at: 'b') = 2.! !

!JSJsonParserTest methodsFor: 'testing-array' stamp: 'pmm 12/15/2008 19:50'!
testEmptyArray
	| result |
	result := self parse: '[]'.
	self assert: result isArray.
	self assert: result isEmpty! !

!JSJsonParserTest methodsFor: 'testing-objects' stamp: 'pmm 12/15/2008 19:58'!
testEmptyObject
	| result |
	result := self parse: '{}'.
	self assert: result isDictionary.
	self assert: result isEmpty! !

!JSJsonParserTest methodsFor: 'testing-real' stamp: 'lr 6/29/2009 14:37'!
testExplorerEvent
	| result |
	result := self parse: '{"recordset": null, "type": "change", "fromElement": null, "toElement": null, "altLeft": false, "keyCode": 0, "repeat": false, "reason": 0, "behaviorCookie": 0, "contentOverflow": false, "behaviorPart": 0, "dataTransfer": null, "ctrlKey": false, "shiftLeft": false, "dataFld": "", "qualifier": "", "wheelDelta": 0, "bookmarks": null, "button": 0, "srcFilter": null, "nextPage": "", "cancelBubble": false, "x": 89, "y": 502, "screenX": 231, "screenY": 1694, "srcUrn": "", "boundElements": {"length": 0}, "clientX": 89, "clientY": 502, "propertyName": "", "shiftKey": false, "ctrlLeft": false, "offsetX": 25, "offsetY": 2, "altKey": false}'.
	self assert: (result at: 'type') = 'change'.
	self assert: (result at: 'offsetY') = 2.
	self deny: (result at: 'altKey').
	self assert: (result at: 'dataTransfer') isNil.
	self assert: (result at: 'nextPage') = ''! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'lr 6/25/2009 23:23'!
testFalse
	self deny: (self parse: 'false')! !

!JSJsonParserTest methodsFor: 'testing-real' stamp: 'lr 6/29/2009 14:36'!
testFirefoxEvent
	| result |
	result := self parse: '{"type": "change", "eventPhase": 2, "bubbles": true, "cancelable": true, "timeStamp": 0, "CAPTURING_PHASE": 1, "AT_TARGET": 2, "BUBBLING_PHASE": 3, "isTrusted": true, "MOUSEDOWN": 1, "MOUSEUP": 2, "MOUSEOVER": 4, "MOUSEOUT": 8, "MOUSEMOVE": 16, "MOUSEDRAG": 32, "CLICK": 64, "DBLCLICK": 128, "KEYDOWN": 256, "KEYUP": 512, "KEYPRESS": 1024, "DRAGDROP": 2048, "FOCUS": 4096, "BLUR": 8192, "SELECT": 16384, "CHANGE": 32768, "RESET": 65536, "SUBMIT": 131072, "SCROLL": 262144, "LOAD": 524288, "UNLOAD": 1048576, "XFER_DONE": 2097152, "ABORT": 4194304, "ERROR": 8388608, "LOCATE": 16777216, "MOVE": 33554432, "RESIZE": 67108864, "FORWARD": 134217728, "HELP": 268435456, "BACK": 536870912, "TEXT": 1073741824, "ALT_MASK": 1, "CONTROL_MASK": 2, "SHIFT_MASK": 4, "META_MASK": 8}'.
	self assert: (result at: 'type') = 'change'.
	self assert: (result at: 'eventPhase') = 2.
	self assert: (result at: 'bubbles').
	self assert: (result at: 'cancelable').
	self assert: (result at: 'BACK') = 536870912! !

!JSJsonParserTest methodsFor: 'testing-invalid' stamp: 'lr 6/25/2009 23:34'!
testInvalidArray
	self assertInvalid: '['.
	self assertInvalid: '[1'.
	self assertInvalid: '[1,'.
	self assertInvalid: '[1,]'.
	self assertInvalid: '[1 2]'.
	self assertInvalid: '[]]'! !

!JSJsonParserTest methodsFor: 'testing-invalid' stamp: 'lr 6/25/2009 23:31'!
testInvalidFalse
	self assertInvalid: 'fa'.
	self assertInvalid: 'falsely'.
	self assertInvalid: 'fabulous'! !

!JSJsonParserTest methodsFor: 'testing-invalid' stamp: 'lr 6/25/2009 23:31'!
testInvalidNull
	self assertInvalid: 'nu'.
	self assertInvalid: 'nuclear'.
	self assertInvalid: 'nullified'! !

!JSJsonParserTest methodsFor: 'testing-invalid' stamp: 'lr 6/25/2009 23:34'!
testInvalidObject
	self assertInvalid: '{'.
	self assertInvalid: '{"a"'.
	self assertInvalid: '{"a":'.
	self assertInvalid: '{"a":"b"'.
	self assertInvalid: '{"a":"b",'.
	self assertInvalid: '{"a"}'.
	self assertInvalid: '{"a":}'.
	self assertInvalid: '{"a":"b",}'.
	self assertInvalid: '{}}'! !

!JSJsonParserTest methodsFor: 'testing-invalid' stamp: 'lr 6/25/2009 23:33'!
testInvalidString
	self assertInvalid: '"'.
	self assertInvalid: '"a'.
	self assertInvalid: '"\"'.
	self assertInvalid: '"\a"'.
	self assertInvalid: '"\u"'.
	self assertInvalid: '"\u1"'.
	self assertInvalid: '"\u12"'.
	self assertInvalid: '"\u123"'.
	self assertInvalid: '"\u123x"'! !

!JSJsonParserTest methodsFor: 'testing-invalid' stamp: 'lr 6/25/2009 23:30'!
testInvalidTrue
	self assertInvalid: 'tr'.
	self assertInvalid: 'trace'.
	self assertInvalid: 'truest'! !

!JSJsonParserTest methodsFor: 'testing-array' stamp: 'pmm 12/15/2008 19:57'!
testNestedArray
	| result |
	result := self parse: '[[2]]'.
	self assert: result isArray.
	self assert: result size = 1.
	result := result first.
	self assert: result isArray.
	self assert: result size = 1.
	self assert: result first = 2.! !

!JSJsonParserTest methodsFor: 'testing-objects' stamp: 'pmm 12/15/2008 19:59'!
testNestedObject
	| result |
	result := self parse: '{"object":{"1":"2"}} '.
	self assert: result isDictionary.
	self assert: result size = 1.
	result := result at: 'object'.
	self assert: result isDictionary.
	self assert: result size = 1.
	self assert: (result at: '1') = '2'.! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'lr 6/25/2009 23:23'!
testNull
	self assert: (self parse: 'null') isNil! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'mlucas-smith 6/29/2009 18:20'!
testNumberFloat
	self assert: (self parse: '0.0') = 0.0.
	self assert: (self parse: '0.12') = 0.12.
	self assert: (self parse: '-0.12') = -0.12.
	self assert: (self parse: '12.34') = 12.34.
	self assert: (self parse: '-12.34') = -12.34.
	self assert: (self parse: '1.2e0') = 1.2.
	self assert: (self parse: '1.2e+1') = 12.0.
	self assert: (self parse: '1.2e-1') = 1.2e-1! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'lr 6/25/2009 23:08'!
testNumberInteger
	self assert: (self parse: '0') = 0.
	self assert: (self parse: '1') = 1.
	self assert: (self parse: '-1') = -1.
	self assert: (self parse: '12') = 12.
	self assert: (self parse: '-12') = -12.
	self assert: (self parse: '1e2') = 100.
	self assert: (self parse: '1e+2') = 100! !

!JSJsonParserTest methodsFor: 'testing-real' stamp: 'lr 6/29/2009 14:36'!
testSafariEvent
	| result |
	result := self parse: '{"returnValue": true, "timeStamp": 1226697417289, "eventPhase": 2, "type": "change", "cancelable": false, "bubbles": true, "cancelBubble": false, "MOUSEOUT": 8, "FOCUS": 4096, "CHANGE": 32768, "MOUSEMOVE": 16, "AT_TARGET": 2, "SELECT": 16384, "BLUR": 8192, "KEYUP": 512, "MOUSEDOWN": 1, "MOUSEDRAG": 32, "BUBBLING_PHASE": 3, "MOUSEUP": 2, "CAPTURING_PHASE": 1, "MOUSEOVER": 4, "CLICK": 64, "DBLCLICK": 128, "KEYDOWN": 256, "KEYPRESS": 1024, "DRAGDROP": 2048}'.
	self assert: (result at: 'type') = 'change'.
	self assert: (result at: 'eventPhase') = 2.
	self assert: (result at: 'bubbles').
	self deny: (result at: 'cancelBubble').
	self deny: (result at: 'cancelable').
	self assert: (result at: 'BLUR') = 8192! !

!JSJsonParserTest methodsFor: 'testing-array' stamp: 'pmm 12/15/2008 19:51'!
testSmallArray
	| result |
	result := self parse: '["a"]'.
	self assert: result isArray.
	self assert: result size = 1.
	self assert: result first = 'a'.! !

!JSJsonParserTest methodsFor: 'testing-objects' stamp: 'pmm 12/15/2008 19:59'!
testSmallObject
	| result |
	result := self parse: '{"a":1}'.
	self assert: result isDictionary.
	self assert: result size = 1.
	self assert: (result at: 'a') = 1! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'lr 6/25/2009 19:58'!
testString
	self assert: (self parse: '""') = ''.
	self assert: (self parse: '"foo"') = 'foo'.
	self assert: (self parse: '"foo bar"') = 'foo bar'! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'lr 7/16/2009 08:50'!
testStringEscaped
	self assert: (self parse: '"\""') = '"'.
	self assert: (self parse: '"\\"') = '\'.
	self assert: (self parse: '"\/"') = '/'.
	self assert: (self parse: '"\b"') = (String with: Character backspace).
	self assert: (self parse: '"\f"') = (String with: Character newPage).
	self assert: (self parse: '"\n"') = (String with: Character lf).
	self assert: (self parse: '"\r"') = (String with: Character cr).
	self assert: (self parse: '"\t"') = (String with: Character tab).
	self assert: (self parse: '"\u20Ac"') = (String with: (Character codePoint: 16r20AC))! !

!JSJsonParserTest methodsFor: 'testing-literals' stamp: 'lr 6/25/2009 23:23'!
testTrue
	self assert: (self parse: 'true')! !

TestCase subclass: #JSJsonStreamTest
	instanceVariableNames: 'printer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Tests-Core'!

!JSJsonStreamTest methodsFor: 'asserting' stamp: 'lr 2/2/2010 21:47'!
assert: anObject equals: aString
	self
		assert: anObject asJson = aString
		description: anObject asJson , ' expected to be ' , aString greaseString
		resumable: true! !

!JSJsonStreamTest methodsFor: 'printing' stamp: 'lr 2/2/2010 22:41'!
jsonOn: aStream
	printer value: aStream! !

!JSJsonStreamTest methodsFor: 'testing' stamp: 'lr 2/2/2010 21:47'!
testArray
	self assert: #(1 2 3) equals: '[1,2,3]'! !

!JSJsonStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:42'!
testCharacter
	self assert: $a equals: '"a"'! !

!JSJsonStreamTest methodsFor: 'testing-custom' stamp: 'lr 2/2/2010 22:41'!
testCustomArray
	printer := [ :stream | stream json: #('aString1' ('aString2' 'aString3')) ].
	self assert: self equals: '["aString1",["aString2","aString3"]]'! !

!JSJsonStreamTest methodsFor: 'testing-custom' stamp: 'lr 2/2/2010 21:48'!
testCustomDictionary
	printer := [ :stream | 
		stream json: (GRSmallDictionary new
			at: 'foo' put: 'bar';
			at: 'zork' put: (GRSmallDictionary new
				at: 'foo' put: 'bar';
				yourself);
			yourself) ].
	self assert: self equals: '{"foo":"bar","zork":{"foo":"bar"}}'! !

!JSJsonStreamTest methodsFor: 'testing' stamp: 'lr 2/2/2010 22:42'!
testDictionary
	self
		assert:
			((GRSmallDictionary new)
				at: 'foo' put: 1;
				at: 'bar' put: 2;
				at: 'zork' put: 3;
				yourself)
		equals: '{"foo":1,"bar":2,"zork":3}'.
	self
		assert:
			((GRSmallDictionary new)
				at: '' put: 'empty';
				yourself)
		equals: '{"":"empty"}'.
	self
		assert:
			((Dictionary new)
				at: 1 put: 'not-a-string';
				yourself)
		equals: '{"1":"not-a-string"}'.
	self
		assert:
			((Dictionary new)
				at: '1abc' put: 'not-an-id';
				yourself)
		equals: '{"1abc":"not-an-id"}'.
	self
		assert:
			((Dictionary new)
				at: 'abc1' put: 'totally sexy';
				yourself)
		equals: '{"abc1":"totally sexy"}'! !

!JSJsonStreamTest methodsFor: 'testing-encoding' stamp: 'lr 2/2/2010 22:40'!
testEncodeArray
	| actual |
	actual := String streamContents: [ :stream |
		JSJsonStream 
			encodeCollection: (Array 
				with: 'something'
				with: (GRSmallDictionary new
					at: 'a' put: '1';
					yourself))
			on: stream ].
	self assert: actual = '["something",{"a":"1"}]'! !

!JSJsonStreamTest methodsFor: 'testing-encoding' stamp: 'lr 2/2/2010 22:41'!
testEncodeDictionary
	| actual |
	actual := String streamContents: [ :stream |
		JSJsonStream 
			encodeDictionary: (GRSmallDictionary new
				at: '1' put: 'a';
				at: '2' put: (GRSmallDictionary new
					at: '3' put: 'c';
					yourself);
				yourself) 
			on: stream ].
	self assert: actual = '{"1":"a","2":{"3":"c"}}'! !

!JSJsonStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:17'!
testLiteral
	self assert: true equals: 'true'.
	self assert: false equals: 'false'.
	self assert: nil equals: 'null'! !

!JSJsonStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:17'!
testNumber
	self assert: 123 equals: '123'.
	self assert: 123.4 equals: '123.4'.! !

!JSJsonStreamTest methodsFor: 'testing' stamp: 'lr 2/6/2010 13:12'!
testObject
	self
		should: [ Object new asJson ]
		raise: Error! !

!JSJsonStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:17'!
testStringBasic
	self assert: 'abc' equals: '"abc"'.
	self assert: '123' equals: '"123"'! !

!JSJsonStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:17'!
testStringEscaping
	self assert: '''' equals: '"''"'.
	self assert: '"' equals: '"\""'.
	self assert: '\' equals: '"\\"'! !

!JSJsonStreamTest methodsFor: 'testing-literals' stamp: 'lr 2/2/2010 22:17'!
testStringSpecial
	self assert: (String with: Character cr) equals: '"\r"'.
	self assert: (String with: Character lf) equals: '"\n"'.
	self assert: (String with: Character tab) equals: '"\t"'.

	self assert: (String with: (Character codePoint: 0)) equals: '"\0"'.
	self assert: (String with: (Character codePoint: 1)) equals: '"\x01"'.
	self assert: (String with: (Character codePoint: 31)) equals: '"\x1f"'! !

!GRPackage class methodsFor: '*javascript-tests-core' stamp: 'lr 2/17/2010 15:11'!
javascriptTestsCore
	^ self new
		name: 'Javascript-Tests-Core';
		description: 'Unit tests for the Javascript-Core package.';
		addDependency: 'Javascript-Core';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
